Bug 500001 - simple febootstrap call terminates with a segfault
simple febootstrap call terminates with a segfault
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: febootstrap (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: Richard W.M. Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-05-09 19:59 EDT by Dennis Jacobfeuerborn
Modified: 2009-12-18 04:24 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 04:24:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
excerpt of "strace -f -o /tmp/log -s 1500 ./febootstrap fedora-10 /tmp/f-10" (2.85 KB, text/plain)
2009-05-11 11:27 EDT, Dennis Jacobfeuerborn
no flags Details

  None (edit)
Description Dennis Jacobfeuerborn 2009-05-09 19:59:06 EDT
Running febootstrap like this:

febootstrap fedora-10 /tmp/f10

results in this:

run_yum: line 1:  8816 Segmentation fault      yum -y -c "$tmpdir"/febootstrap.repo --disablerepo=* --enablerepo=febootstrap --noplugins --nogpgcheck --installroot="$target" install "$@"

Installed packages:

fakeroot-1.12.2-21.fc10.i386
fakechroot-2.9-19.fc10.i386
febootstrap-1.9-1.fc10.noarch
yum-3.2.21-2.fc10.noarch
Comment 1 Dennis Jacobfeuerborn 2009-05-09 20:02:15 EDT
I should add that I get this error running febootstrap as normal user. Running it as root does not result in a segfault.
Comment 2 Richard W.M. Jones 2009-05-10 04:00:50 EDT
Just a comment - you probably don't want to be running febootstrap as root.
Comment 3 Richard W.M. Jones 2009-05-10 04:07:40 EDT
This works for me, although I have a slightly different mix
of packages installed:

fakeroot-1.12.2-21.fc10.x86_64
fakechroot-2.9-22.fc12.x86_64
febootstrap-1.7-1.fc12.noarch
yum-3.2.21-2.fc10.noarch

and also I'm on x86-64.

So .. I would say this is either because of my more recent
fakechroot (that one comes from Rawhide), or because of the
architecture difference.

So can you try with fakechroot from here:
http://koji.fedoraproject.org/koji/buildinfo?buildID=98543

If that works, then I'll backport the changes to F-10.  If not,
then it must be an i386 vs x86-64 thing (although I have
built and used febootstrap on i386 plenty of times, so it
certainly *should* work).
Comment 4 Dennis Jacobfeuerborn 2009-05-10 16:12:10 EDT
(In reply to comment #2)
> Just a comment - you probably don't want to be running febootstrap as root.  

That's what I thought. I saw that there is a different codepath when you run it as root and wanted to see if that shows the same problem (would have made debugging a lot easier).

(In reply to comment #3)
> This works for me, although I have a slightly different mix
> of packages installed:
> 
> fakeroot-1.12.2-21.fc10.x86_64
> fakechroot-2.9-22.fc12.x86_64
> febootstrap-1.7-1.fc12.noarch
> yum-3.2.21-2.fc10.noarch
> 
> and also I'm on x86-64.
> 
> So .. I would say this is either because of my more recent
> fakechroot (that one comes from Rawhide), or because of the
> architecture difference.
> 
> So can you try with fakechroot from here:
> http://koji.fedoraproject.org/koji/buildinfo?buildID=98543
> 
> If that works, then I'll backport the changes to F-10.  If not,
> then it must be an i386 vs x86-64 thing (although I have
> built and used febootstrap on i386 plenty of times, so it
> certainly *should* work).  

With that version of fakechroot I get the same error. I was thinking about using gdb to get a backtrace but I have no idea how to get that properly into the fakeroot/fakechroot/bash/run_yum dance in the febootstrap script.

(ps: I missed bug 500000 by 1? Damn you Dag Wieers! :)
Comment 5 Richard W.M. Jones 2009-05-10 16:17:15 EDT
I'll just see if I can reproduce this on a (newly installed ...)
F-10 i386 box.
Comment 6 Richard W.M. Jones 2009-05-11 07:14:13 EDT
OK I built a F-10 i386 virtual machine and I cannot unfortunately
reproduce this.

I was testing with febootstrap from git, but I'm not sure why
that would make a difference as febootstrap 1.9 and from git
are hardly different from each other.

Packages I had installed:

 fakeroot-1.12.2-21.fc10.i386
 fakechroot-2.9-19.fc10.i386
 yum-3.2.21-2.fc10.noarch

Can you try this please:

 git clone git://git.et.redhat.com/febootstrap.git
 cd febootstrap
 ./autogen.sh
 make
 ./febootstrap fedora-10 /tmp/f-10

You will need the following additional packages installed for the
above to work:

 - git
 - automake
 - autoconf

If the above doesn't work, then I'm not sure what is happening.

Debugging fakeroot/fakechroot is possible, albeit difficult.  I found
it most helpful at first to use 'strace -f -o /tmp/log -s 1500 ...'
and look at what system call(s) the program executes before it
crashes, and then to compare those to what fakechroot is doing.

The only other things I can think of at the moment:

 - running out of memory?
 - strange, malformed, or very long environment variables?
Comment 7 Dennis Jacobfeuerborn 2009-05-11 11:27:29 EDT
Created attachment 343468 [details]
excerpt of "strace -f -o /tmp/log -s 1500 ./febootstrap fedora-10 /tmp/f-10"

Using the git version I get the same error. I'm running the PAE kernel with 4GB of RAM. "top" shows 3.9gb as total, 1.3gb as free and 1.4gb as used as cache.

I attached the last few lines of the strace right up to when the segfault occurs. The process seems to bomb right after the mmap2 call even though that seems to succeed. Not sure why that is. Process 15241 seems to be the yum call:

15241 execve("/usr/bin/python", ["/usr/bin/python", "/usr/bin/yum", "-y", "-c", "/tmp/tmp.frdut8omsq/febootstrap.repo", 
"--disablerepo=*", "--enablerepo=febootstrap", "--noplugins", "--nogpgcheck", "--installroot=/tmp/f-10", "install", "@Co
re"], [/* 54 vars */]) = 0
Comment 8 Bug Zapper 2009-11-18 06:55:26 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Bug Zapper 2009-12-18 04:24:52 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.